import * as Options from '../Options';
import Client from '../Client';
export declare function get(client: Client, username?: string): Promise<APIResponse<AccountResponse>>;
export declare function galleryFavorites(client: Client, username?: string | null, options?: Options.PageOption & Options.AccountCommentSortOption): Promise<APIResponse<BaseGalleryResponse[]>>;
export declare function favorites(client: Client, username?: string | null, options?: Options.PageOption & Options.AccountFavoriteSortOption): Promise<APIResponse<BaseGalleryResponse[]>>;
export declare function submissions(client: Client, username?: string | null, page?: number): Promise<APIResponse<BaseGalleryResponse[]>>;
export declare function settings(client: Client): Promise<APIResponse<AccountResponse>>;
export declare function changeSettings(client: Client, options: Options.ChangeAccountSettingsOptions): Promise<APIResponse<boolean>>;
export declare function galleryProfile(client: Client, username?: string): Promise<APIResponse<GalleryProfileResponse>>;
export declare function verifyEmail(client: Client, username?: string): Promise<APIResponse<boolean>>;
export declare function sendVerificationEmail(client: Client): Promise<APIResponse<boolean>>;
export declare function albums(client: Client, username?: string | null, page?: number): Promise<APIResponse<AlbumResponse[]>>;
export declare function album(client: Client, username: string | null, albumId: string): Promise<APIResponse<AlbumResponse>>;
export declare function albumIds(client: Client, username?: string | null, page?: number): Promise<APIResponse<number[]>>;
export declare function albumCount(client: Client, username?: string): Promise<APIResponse<number>>;
export declare function albumRemove(client: Client, username: string | null, albumId: string): Promise<APIResponse<boolean>>;
export declare function comments(client: Client, username?: string | null, options?: Options.AccountCommentSortOption & Options.PageOption): Promise<APIResponse<CommentResponse[]>>;
export declare function comment(client: Client, username: string | null, commentId: string): Promise<APIResponse<CommentResponse>>;
export declare function commentIds(client: Client, username?: string | null, options?: Options.AccountCommentSortOption & Options.PageOption): Promise<APIResponse<number[]>>;
export declare function commentCount(client: Client, username?: string): Promise<APIResponse<number>>;
export declare function commentRemove(client: Client, commentId: string): Promise<APIResponse<boolean>>;
export declare function images(client: Client, username?: string | null, page?: number): Promise<APIResponse<ImageResponse[]>>;
export declare function image(client: Client, username: string | null, imageId: string): Promise<APIResponse<ImageResponse>>;
export declare function imageIds(client: Client, username?: string | null, page?: number): Promise<APIResponse<string[]>>;
export declare function imageCount(client: Client, username?: string): Promise<APIResponse<number>>;
export declare function imageRemove(client: Client, username: string | null, deleteHash: string): Promise<APIResponse<boolean>>;
export declare function replies(client: Client): Promise<APIResponse<NotificationResponse[]>>;
